A. Nastya and an Array
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Nastya owns too many arrays now, so she wants to delete the least important of them. However, she discovered that this array is magic! Nastya now knows that the array has the following properties:

  • In one second we can add an arbitrary (possibly negative) integer to all elements of the array that are not equal to zero.
  • When all elements of the array become equal to zero, the array explodes.

Nastya is always busy, so she wants to explode the array as fast as possible. Compute the minimum time in which the array can be exploded.

Input

The first line contains a single integer nn (1≤n≤1051≤n≤105) — the size of the array.

The second line contains nn integers a1,a2,…,ana1,a2,…,an (−105≤ai≤105−105≤ai≤105) — the elements of the array.


判除0外不同数字的个数。

 #include<bits/stdc++.h>
#define clr(x) memset(x,0,sizeof(x))
#define clr_1(x) memset(x,-1,sizeof(x))
#define INF 0x3f3f3f3f
#define LL long long
#define pb push_back
#define mod 1000000007
#define ls(i) (i<<1)
#define rs(i) (i<<1|1)
#define mp make_pair
#define fi first
#define se second
using namespace std;
const int N=1e5+;
set<LL> num;
int a[N];
int n;
int main()
{
cin>>n;
for(int i=;i<=n;i++){
cin>>a[i];
if(a[i]==) continue;
num.insert(a[i]);
}
printf("%d\n",num.size());
return ;
}
B. Nastya Studies Informatics
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Today on Informatics class Nastya learned about GCD and LCM (see links below). Nastya is very intelligent, so she solved all the tasks momentarily and now suggests you to solve one of them as well.

We define a pair of integers (a,b)(a,b) good, if GCD(a,b)=xGCD(a,b)=x and LCM(a,b)=yLCM(a,b)=y, where GCD(a,b)GCD(a,b) denotes the greatest common divisor of aa and bb, and LCM(a,b)LCM(a,b) denotes the least common multiple of aa and bb.

You are given two integers xx and yy. You are to find the number of good pairs of integers (a,b)(a,b) such that l≤a,b≤rl≤a,b≤r. Note that pairs (a,b)(a,b) and (b,a)(b,a) are considered different if a≠ba≠b.

Input

The only line contains four integers l,r,x,yl,r,x,y (1≤l≤r≤1091≤l≤r≤109, 1≤x≤y≤1091≤x≤y≤109).

Output

In the only line print the only integer — the answer for the problem.

Examples
input

Copy
1 2 1 2
output

Copy
2
input

Copy
1 12 1 12
output

Copy
4
input

Copy
50 100 3 30
output

Copy
0
Note

In the first example there are two suitable good pairs of integers (a,b)(a,b): (1,2)(1,2) and (2,1)(2,1).

In the second example there are four suitable good pairs of integers (a,b)(a,b): (1,12)(1,12), (12,1)(12,1), (3,4)(3,4) and (4,3)(4,3).

In the third example there are good pairs of integers, for example, (3,30)(3,30), but none of them fits the condition l≤a,b≤rl≤a,b≤r.


在sqrt(y) 范围内把所有可能的因数暴力找出来,然后暴力跑一遍这所有因数p和lcm/p看他们符不符合 $ p \ge l ,y/p \ge l $ 以及 $ p \le r , y/p \le r $ 并且 $ gcd(p,ly/p)==x $ 就行。符合就ans++。

 #include<bits/stdc++.h>
#define clr(x) memset(x,0,sizeof(x))
#define clr_1(x) memset(x,-1,sizeof(x))
#define INF 0x3f3f3f3f
#define LL long long
#define pb push_back
#define mod 1000000007
#define ls(i) (i<<1)
#define rs(i) (i<<1|1)
#define mp make_pair
#define fi first
#define se second
using namespace std;
const int N=4e4+;
const int P=4e4;
typedef pair<LL,LL> pll;
int inf[N],pri[N];
int tot;
void init()
{
tot=;
for(int i=;i<=P;i++)
{
if(!inf[i])
pri[++tot]=i;
for(int j=;j<=tot && pri[j]*i<=P;j++)
{
inf[i*pri[j]]=;
if(i%pri[j]==) break;
}
}
return ;
}
set<LL> dive;
set<pll> ans;
int l,r,lcm,gcd;
bool infer(LL t)
{
return t>=l && t<=r;
}
int num[N];
int main()
{
scanf("%d%d%d%d",&l,&r,&gcd,&lcm);
for(LL d=;d*d<=lcm;d++)
if(lcm%d==)
dive.insert(d),dive.insert(lcm/d);
for(auto p:dive)
{
LL xx=gcd*p,yy=lcm/p;
if(infer(xx) && infer(yy) && __gcd(xx,yy)==gcd) ans.insert(mp(xx,yy));
}
printf("%d\n",ans.size());
return ;
}
C. Nastya and a Wardrobe
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Nastya received a gift on New Year — a magic wardrobe. It is magic because in the end of each month the number of dresses in it doubles (i.e. the number of dresses becomes twice as large as it is in the beginning of the month).

Unfortunately, right after the doubling the wardrobe eats one of the dresses (if any) with the 50%50% probability. It happens every month except the last one in the year.

Nastya owns xx dresses now, so she became interested in the expected number of dresses she will have in one year. Nastya lives in Byteland, so the year lasts for k+1k+1 months.

Nastya is really busy, so she wants you to solve this problem. You are the programmer, after all. Also, you should find the answer modulo 109+7109+7, because it is easy to see that it is always integer.

Input

The only line contains two integers xx and kk (0≤x,k≤10180≤x,k≤1018), where xx is the initial number of dresses and k+1k+1 is the number of months in a year in Byteland.

Output

In the only line print a single integer — the expected number of dresses Nastya will own one year later modulo 109+7109+7.

Examples
input

Copy
2 0
output

Copy
4
input

Copy
2 1
output

Copy
7
input

Copy
3 2
output

Copy
21
Note

In the first example a year consists on only one month, so the wardrobe does not eat dresses at all.

In the second example after the first month there are 33 dresses with 50%50% probability and 44 dresses with 50%50% probability. Thus, in the end of the year there are 66 dresses with 50%50% probability and 88 dresses with 50%50% probability. This way the answer for this test is (6+8)/2=7(6+8)/2=7.


把期望计算式列出来可以发现这个答案就是一个式子。注意一下n的大小处理。

 #include<bits/stdc++.h>
#define clr(x) memset(x,0,sizeof(x))
#define clr_1(x) memset(x,-1,sizeof(x))
#define INF 0x3f3f3f3f
#define LL long long
#define pb push_back
#define mod 1000000007
#define ls(i) (i<<1)
#define rs(i) (i<<1|1)
#define mp make_pair
#define fi first
#define se second
using namespace std;
LL n,k;
LL quickpow(LL x,LL n)
{
LL ans=;
x%=mod;
while(n)
{
if(n&)
ans=ans*x%mod;
x=x*x%mod;
n>>=;
}
return ans%mod;
}
int main()
{
cin>>n>>k;
if(n==)
printf("0\n");
else
{
n%=mod;
LL ans=((quickpow(,k+)*n%mod-(quickpow(,k)-+mod)%mod)%mod+mod)%mod;
ans%=mod;
printf("%I64d\n",ans);
}
return ;
}
D. Nastya and a Game
time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Nastya received one more array on her birthday, this array can be used to play a traditional Byteland game on it. However, to play the game the players should first select such a subsegment of the array that ps=kps=k, where pp is the product of all integers on the given array, ss is their sum, and kk is a given constant for all subsegments.

Nastya wonders how many subsegments of the array fit the described conditions. A subsegment of an array is several consecutive integers of the array.

Input

The first line contains two integers nn and kk (1≤n≤2⋅1051≤n≤2⋅105, 1≤k≤1051≤k≤105), where nn is the length of the array and kk is the constant described above.

The second line contains nn integers a1,a2,…,ana1,a2,…,an (1≤ai≤1081≤ai≤108) — the elements of the array.

Output

In the only line print the number of subsegments such that the ratio between the product and the sum on them is equal to kk.

Examples
input

Copy
1 1
1
output

Copy
1
input

Copy
4 2
6 3 8 1
output

Copy
2
Note

In the first example the only subsegment is [1][1]. The sum equals 11, the product equals 11, so it suits us because 11=111=1.

There are two situable subsegments in the second example — [6,3][6,3] and [3,8,1][3,8,1]. Subsegment [6,3][6,3] has sum 99 and product 1818, so it suits us because 189=2189=2. Subsegment [3,8,1][3,8,1] has sum 1212 and product 2424, so it suits us because 2412=22412=2.


我们看到数据范围,可以发现k*sum<= 2e18, 因此乘积不可能大于2e18,一旦大于往后就没有匹配线段了。我们枚举所有线段左端点,然后往后暴力跳右端点。我们每次跳的位置是一个非1的位置,这样最多跳60次。每次跳的范围内最多产生1个答案贡献。

 #include<bits/stdc++.h>
#define clr(x) memset(x,0,sizeof(x))
#define clr_1(x) memset(x,-1,sizeof(x))
#define INF 0x3f3f3f3f
#define LL long long
#define pb push_back
#define ls(i) (i<<1)
#define rs(i) (i<<1|1)
#define mp make_pair
#define fi first
#define se second
using namespace std;
const int N=2e5+;
const LL eps=1e18;
typedef pair<LL,LL> pll;
LL a[N];
LL aft[N];
LL ans;
int main()
{
int n;
LL k;
scanf("%d",&n);
scanf("%I64d",&k);
ans=;
for(int i=;i<=n;i++)
scanf("%I64d",a+i);
aft[n+]=n+;
aft[n]=n;
for(int i=n-;i>=;i--)
if(a[i]>) aft[i]=i;
else aft[i]=aft[i+];
LL sum,mul;
int pre,suf;
for(int i=;i<=n;i++)
{
sum=;
mul=;
suf=i;
pre=i-;
while(suf<=n)
{
sum+=a[suf];
if(eps/a[suf]<mul)
break;
mul*=a[suf];
pre=suf;
suf=aft[suf+];
if(mul%k== && mul/k>=sum && mul/k<=sum+suf-pre-)
ans++;
sum+=suf-pre-;
}
}
printf("%I64d\n",ans);
return ;
}
E. Nastya and King-Shamans
time limit per test

3 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Nastya likes reading and even spends whole days in a library sometimes. Today she found a chronicle of Byteland in the library, and it stated that there lived shamans long time ago. It is known that at every moment there was exactly one shaman in Byteland, and there were nn shamans in total enumerated with integers from 11 to nn in the order they lived. Also, each shaman had a magic power which can now be expressed as an integer.

The chronicle includes a list of powers of the nn shamans. Also, some shamans can be king-shamans, if they gathered all the power of their predecessors, i.e. their power is exactly the sum of powers of all previous shamans. Nastya is interested in whether there was at least one king-shaman in Byteland.

Unfortunately many of the powers are unreadable in the list, so Nastya is doing the following:

  • Initially she supposes some power for each shaman.
  • After that she changes the power of some shaman qq times (the shamans can differ) and after that wants to check if there is at least one king-shaman in the list. If yes, she wants to know the index of any king-shaman.

Unfortunately the list is too large and Nastya wants you to help her.

Input

The first line contains two integers nn and qq (1≤n,q≤2⋅1051≤n,q≤2⋅105).

The second line contains nn integers a1,…,ana1,…,an (0≤ai≤1090≤ai≤109), where aiai is the magic power of the ii-th shaman.

After that qq lines follow, the ii-th of them contains two integers pipi and xixi (1≤pi≤n1≤pi≤n, 0≤xi≤1090≤xi≤109) that mean that the new power of the pipi-th shaman is xixi.

Output

Print qq lines, the ii-th of them should contain −1−1, if after the ii-th change there are no shaman-kings, and otherwise a single integer jj, where jj is an index of some king-shaman after the ii-th change.

If there are multiple king-shamans after each change, print the index of any of them.

Examples
input

Copy
2 1
1 3
1 2
output

Copy
-1
input

Copy
3 4
2 2 3
1 1
1 2
2 4
3 6
output

Copy
3
2
-1
3
input

Copy
10 7
0 3 1 4 6 2 7 8 10 1
2 5
1 3
9 36
4 10
4 9
1 2
1 0
output

Copy
1
-1
9
-1
4
-1
1
Note

In the first example powers of shamans after the first change are equal to (2,3)(2,3). The answer equals −1−1, because the sum of powers of shamans before the first shaman is equal to 00, and before the second is equal to 22.

In the second example after the first change the powers are equal to (1,2,3)(1,2,3). The answer is equal to 33, because the power of the third shaman is equal to 33, and the sum of powers of the first and the second shaman is also 1+2=31+2=3. After the second change the powers become equal to (2,2,3)(2,2,3), where the answer equals 22. After the third change the powers become equal to (2,4,3)(2,4,3), where the answer equals −1−1. After the fourth change the powers become equal to (2,4,6)(2,4,6), where the answer equals 33.


我们用bit存前缀和。然后我们在询问修改后,从tmp=a[1]开始,每次寻找一个位置t,它的前缀和大小pre不超过tmp*2-1,然后看t+1位置符不符合a[t+1] == pre[t] ,不符合则修改tmp为pre[t+1]继续倍增。由于我们要寻找的位置是a[p] == pre[p-1] 的这个p位置,因此这个倍增能很快速地在log2(n)*log2(n)的复杂度找到这个p位置。

 #include<bits/stdc++.h>
#define clr(x) memset(x,0,sizeof(x))
#define clr_1(x) memset(x,-1,sizeof(x))
#define INF 0x3f3f3f3f
#define LL long long
#define pb push_back
#define ls(i) (i<<1)
#define rs(i) (i<<1|1)
#define mp make_pair
#define fi first
#define se second
using namespace std;
const int N=(<<)+;
const int maxn=<<;
int n,q;
LL bits[N];
LL a[N];
void add(int i,LL x)
{
while(i<=maxn)
{
bits[i]+=x;
i += i & -i;
}
return ;
}
LL sum(int i)
{
LL ans=;
while(i)
{
ans+=bits[i];
i -= i & -i;
}
return ans;
}
int upt(LL x)
{
if(bits[maxn]<=x) return INF;
int p=;
LL res=;
for(int i=;i>=;i--)
if(res+bits[p|(<<i)]<=x)
{
res+=bits[p|(<<i)];
p|=(<<i);
}
return p+;
}
int main()
{
scanf("%d%d",&n,&q);
for(int i=;i<=n;i++)
{
scanf("%I64d",a+i);
add(i,a[i]);
}
while(q--)
{
int pos;
LL val;
scanf("%d%I64d",&pos,&val);
add(pos,val-a[pos]);
a[pos]=val;
LL tmp=a[];
LL ans=-;
if(tmp==)
{
printf("1\n");
continue;
}
while(tmp<INF)
{
int k=upt(*tmp-);
if(k==INF)
break;
if(sum(k-)==a[k])
{
ans=k;
break;
}
tmp=sum(k-)+a[k];
}
printf("%I64d\n",ans);
}
return ;
}

Codeforces Round #489 (Div. 2)的更多相关文章

  1. 【伪暴力+智商剪枝】Codeforces Round #489 (Div. 2) D

    失踪人口突然回归……orz.题解还是有必要写的,虽然估计只有自己(?自己也不一定看得懂)看得懂. 题目链接:http://codeforces.com/contest/992/problem/D 题目 ...

  2. Codeforces Round #489 (Div. 2) E. Nastya and King-Shamans(线段树)

    题意 给出一个长度为 \(n\) 的序列 \(\{a_i\}\) , 现在会进行 \(m\) 次操作 , 每次操作会修改某个 \(a_i\) 的值 , 在每次操作完后你需要判断是否存在一个位置 \(i ...

  3. Codeforces Round #489 (Div. 2) E - Nastya and King-Shamans

    E - Nastya and King-Shamans 题目大意:有n个数,每一次操作更改一个数,每次操作之后问你是否有一个数等于其前面所有数的和. 思路:好题,想了很久没想出来,看了题解,主要思想就 ...

  4. Codeforces Round #489 (Div. 2) B、C

    B. Nastya Studies Informatics time limit per test 1 second memory limit per test 256 megabytes input ...

  5. [Codeforces]Codeforces Round #489 (Div. 2)

    Nastya and an Array 输出有几种不同的数字 #pragma comment(linker, "/STACK:102400000,102400000") #ifnd ...

  6. Codeforces Round #366 (Div. 2) ABC

    Codeforces Round #366 (Div. 2) A I hate that I love that I hate it水题 #I hate that I love that I hate ...

  7. Codeforces Round #354 (Div. 2) ABCD

    Codeforces Round #354 (Div. 2) Problems     # Name     A Nicholas and Permutation standard input/out ...

  8. Codeforces Round #368 (Div. 2)

    直达–>Codeforces Round #368 (Div. 2) A Brain’s Photos 给你一个NxM的矩阵,一个字母代表一种颜色,如果有”C”,”M”,”Y”三种中任意一种就输 ...

  9. cf之路,1,Codeforces Round #345 (Div. 2)

     cf之路,1,Codeforces Round #345 (Div. 2) ps:昨天第一次参加cf比赛,比赛之前为了熟悉下cf比赛题目的难度.所以做了round#345连试试水的深浅.....   ...

随机推荐

  1. tensorflow环境安装

    tensorflow环境安装1.安装虚拟机Virtrualbox下载地址:https://www.virtualbox.org/wiki/Downloads 2.下载安装Ubuntu镜像下载地址:ht ...

  2. win10系统下我的电脑右键没有属性

    1.右键点击系统左下角的开始,菜单中点击运行 2.在输入框中输入regeidt,点击确定打开系统的注册表编辑器 3.然后依次打开HKEY_CURRENT_USER\Software\Microsoft ...

  3. 爬虫基础---HTTP协议理解、网页的基础知识、爬虫的基本原理

    一.HTTP协议的理解 URL和URI 在学习HTTP之前我们需要了解一下URL.URI(精确的说明某资源的位置以及如果去访问它) URL:Universal Resource Locator 统一资 ...

  4. Pytorch数据变换(Transform)

    实例化数据库的时候,有一个可选的参数可以对数据进行转换,满足大多神经网络的要求输入固定尺寸的图片,因此要对原图进行Rescale或者Crop操作,然后返回的数据需要转换成Tensor如: import ...

  5. spring学习之一概念

    概念 1.是开源的轻量级框架 2.是一站式框架,就是说在java ee的三层结构中,每一层它都提供了不同的解决技术 web层:springMVC servoce层:spring IOC ,控制反转,通 ...

  6. java基础81 jsp的内置对象(网页知识)

    1.什么是内置对象? 在jsp开发中,会频繁使用到一些对象,如:HttpSession,ServletContext,HttpServletRequest.      如果每次使用这些对象时,都要去创 ...

  7. poj 2369(置换群)

    Permutations Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 3041   Accepted: 1641 Desc ...

  8. 使用celery时要注意的任务调用形式

    因为之前,一直用django和celery紧密集成,不分家. 所以使用时参考了网上的配置之后,没有变更过. 最近,和洪军想用k8s的pod重新规划系统构架时,这个问题才又浮了出来. 只是我们的task ...

  9. 使用Kafka、Elasticsearch、Grafana搭建业务监控系统(三)Elasticsearch

    https://blog.csdn.net/tonywu1992/article/details/83576863

  10. android拾遗——Android Intent详解

    一. Intent 作用 Intent 是一个将要执行的动作的抽象的描述,一般来说是作为参数来使用,由Intent来协助完成android各个组件之间的通讯.比如说调用startActivity()来 ...